
class InteractiveGif {
  PImage[] frames;
  String filename;
  Gif file;
  Boolean bActive;
  float x, y, w, h;
  float mousePct;
  int frameIndex;
  Boolean bLoaded;
  
  InteractiveGif() {
    bActive = false;
    mousePct = 0.0;
    frameIndex = 0;
    bLoaded = true;
  }
  void load(PApplet parent, String location ) {
    filename = location;
    file = new Gif( parent, filename);
    frames = Gif.getPImages( parent, filename );
    w = frames[0].width;
    h = frames[0].height;
    bLoaded = true;
  }
  void play() {
    file.play();
  }
  
  void render() {
    if(bActive) {
      fill(255, 0, 0);
      rect(x-2, y-2, w+4, h+4);
      frameIndex = (int)map(mousePct, 0.0, 1.0, 0, frames.length);
      if(frameIndex > frames.length-1) frameIndex = frames.length-1;
      image(frames[frameIndex], x, y );
    } else {
      fill(255);
      image( file, x, y);
    }
    
    if(bActive) {
      fill(255);
      noStroke();
      float rx = map( mousePct, 0.0, 1.0, x, x + w-3);
      rect(rx, y, 3, h);
    }
  }
  
  Boolean mouseOver( float mx, float my ) {
    if(mx >= x && mx <= x + w) {
      if(my >= y && my <= y + h) {
        bActive = true;
        mousePct = (mx - x) / w;
        if(mousePct > 1.0) mousePct = 1.0;
        if(mousePct < 0.0) mousePct = 0.0;
        return true;
      }
    }
    bActive = false;
    return false;
  }
};
